import { inject, customElement, bindable } from "aurelia";
import Prism from "prismjs";
import "prismjs/components/prism-cmake.js";
import "prismjs/components/prism-javascript.js";
import "prismjs/components/prism-json.js";
import "prismjs/plugins/line-numbers/prism-line-numbers.js";
const styles$1 = "code[class*=language-],pre[class*=language-]{color:#ccc;background:none;font-family:Consolas,Monaco,Andale Mono,Ubuntu Mono,monospace;font-size:1em;text-align:left;white-space:pre;word-spacing:normal;word-break:normal;word-wrap:normal;line-height:1.5;-moz-tab-size:4;-o-tab-size:4;tab-size:4;-webkit-hyphens:none;-moz-hyphens:none;-ms-hyphens:none;hyphens:none}pre[class*=language-]{padding:1em;margin:.5em 0;overflow:auto}:not(pre)>code[class*=language-],pre[class*=language-]{background:#2d2d2d}:not(pre)>code[class*=language-]{padding:.1em;border-radius:.3em;white-space:normal}.token.comment,.token.block-comment,.token.prolog,.token.doctype,.token.cdata{color:#999}.token.punctuation{color:#ccc}.token.tag,.token.attr-name,.token.namespace,.token.deleted{color:#e2777a}.token.function-name{color:#6196cc}.token.boolean,.token.number,.token.function{color:#f08d49}.token.property,.token.class-name,.token.constant,.token.symbol{color:#f8c555}.token.selector,.token.important,.token.atrule,.token.keyword,.token.builtin{color:#cc99cd}.token.string,.token.char,.token.attr-value,.token.regex,.token.variable{color:#7ec699}.token.operator,.token.entity,.token.url{color:#67cdcc}.token.important,.token.bold{font-weight:700}.token.italic{font-style:italic}.token.entity{cursor:help}.token.inserted{color:green}pre[class*=language-].line-numbers{position:relative;padding-left:3.8em;counter-reset:linenumber}pre[class*=language-].line-numbers>code{position:relative;white-space:inherit}.line-numbers .line-numbers-rows{position:absolute;pointer-events:none;top:0;font-size:100%;left:-3.8em;width:3em;letter-spacing:-1px;border-right:1px solid #999;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.line-numbers-rows>span{display:block;counter-increment:linenumber}.line-numbers-rows>span:before{content:counter(linenumber);color:#999;display:block;padding-right:.8em;text-align:right}.my-editor{background-color:#2d2d2d;color:#ccc;height:auto!important;font-family:Fira code,Fira Mono,Consolas,Menlo,Courier,monospace;font-size:14px;line-height:1.5;padding:1em}.prism-editor-wrapper{width:100%;height:100%;display:flex;align-items:flex-start;overflow:auto;tab-size:1.5em;-moz-tab-size:1.5em}@media all and (-ms-high-contrast: none),(-ms-high-contrast: active){.prism-editor-wrapper .prism-editor__textarea{color:transparent!important}.prism-editor-wrapper .prism-editor__textarea::selection{background-color:#accef7!important;color:transparent!important}}.prism-editor-wrapper .prism-editor__container{position:relative;text-align:left;box-sizing:border-box;padding:0;overflow:hidden;width:100%}.prism-editor-wrapper .prism-editor__line-numbers{height:100%;overflow:hidden;flex-shrink:0;padding-top:4px;margin-top:0;margin-right:10px}.prism-editor-wrapper .prism-editor__line-number{text-align:right;white-space:nowrap}.prism-editor-wrapper .prism-editor__textarea{position:absolute;top:0;left:0;height:100%;width:100%;resize:none;color:inherit;overflow:hidden;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;-webkit-text-fill-color:transparent}.prism-editor-wrapper .prism-editor__textarea:focus{outline:none!important}.prism-editor-wrapper .prism-editor__textarea,.prism-editor-wrapper .prism-editor__editor{margin:0;border:0;background:none;box-sizing:inherit;display:inherit;font-family:inherit;font-size:inherit;font-style:inherit;font-variant-ligatures:inherit;font-weight:inherit;letter-spacing:inherit;line-height:inherit;-moz-tab-size:inherit;tab-size:inherit;text-indent:inherit;text-rendering:inherit;text-transform:inherit;white-space:pre-wrap;word-wrap:keep-all;overflow-wrap:break-word;padding:0}.prism-editor-wrapper .prism-editor__textarea--empty{-webkit-text-fill-color:inherit!important}.prism-editor-wrapper .prism-editor__editor{position:relative;pointer-events:none}";
const template$1 = `<div class="prism-editor">
  <div class="prism-editor-wrapper my-editor" language.bind="language">

    <div
      if.bind="lines"
      aria-hidden="true"
      class="prism-editor__line-numbers"
      style.bind="{ minHeight: lineNumbersHeight }">
        <div
          class="prism-editor__line-width-calc"
          style="height: 0px; visibility: hidden; pointer-events: none;">
          999
        </div>
        <div repeat.for="i of lineNumbersCount" class="prism-editor__line-number token comment">\${i+1}</div>
    </div>
    <div class="prism-editor__container">
      <textarea
      value.bind="code"
      style="padding-top:4px"
      ref="textAreaRef"
      spellcheck="false"
      autocapitalize="off"
      autocomplete="off"
      autocorrect="off"
      data-gramm="false"
      placeholder.bind="placeholder"
      readonly.bind="readonly"
      data-testid="textarea"
      class="prism-editor__textarea \${isEmpty ? 'prism-editor__textarea--empty' : ''}"
    >
    </textarea>
    <pre ref="preRef"
      data-testid="preview"
      class="prism-editor__editor"
      style="padding-top:4px; border-top-left-radius: 0px; border-bottom-left-radius: 0px;"
      innerhtml.bind="content"
    ></pre>
    </div>
  </div>
</div>
`;
var __create$1 = Object.create;
var __defProp$1 = Object.defineProperty;
var __getOwnPropDesc$1 = Object.getOwnPropertyDescriptor;
var __knownSymbol$1 = (name, symbol) => (symbol = Symbol[name]) ? symbol : Symbol.for("Symbol." + name);
var __typeError$1 = (msg) => {
  throw TypeError(msg);
};
var __defNormalProp$1 = (obj, key, value) => key in obj ? __defProp$1(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __name$1 = (target, value) => __defProp$1(target, "name", { value, configurable: true });
var __decoratorStart$1 = (base) => [, , , __create$1(null)];
var __decoratorStrings$1 = ["class", "method", "getter", "setter", "accessor", "field", "value", "get", "set"];
var __expectFn$1 = (fn) => fn !== void 0 && typeof fn !== "function" ? __typeError$1("Function expected") : fn;
var __decoratorContext$1 = (kind, name, done, metadata, fns) => ({ kind: __decoratorStrings$1[kind], name, metadata, addInitializer: (fn) => done._ ? __typeError$1("Already initialized") : fns.push(__expectFn$1(fn || null)) });
var __decoratorMetadata$1 = (array, target) => __defNormalProp$1(target, __knownSymbol$1("metadata"), array[3]);
var __runInitializers$1 = (array, flags, self, value) => {
  for (var i = 0, fns = array[flags >> 1], n = fns && fns.length; i < n; i++) flags & 1 ? fns[i].call(self) : value = fns[i].call(self, value);
  return value;
};
var __decorateElement$1 = (array, flags, name, decorators, target, extra) => {
  var fn, it, done, ctx, access, k = flags & 7, s = !!(flags & 8), p = !!(flags & 16);
  var j = k > 3 ? array.length + 1 : k ? s ? 1 : 2 : 0, key = __decoratorStrings$1[k + 5];
  var initializers = k > 3 && (array[j - 1] = []), extraInitializers = array[j] || (array[j] = []);
  var desc = k && (!p && !s && (target = target.prototype), k < 5 && (k > 3 || !p) && __getOwnPropDesc$1(k < 4 ? target : { get [name]() {
    return __privateGet$1(this, extra);
  }, set [name](x) {
    return __privateSet$1(this, extra, x);
  } }, name));
  k ? p && k < 4 && __name$1(extra, (k > 2 ? "set " : k > 1 ? "get " : "") + name) : __name$1(target, name);
  for (var i = decorators.length - 1; i >= 0; i--) {
    ctx = __decoratorContext$1(k, name, done = {}, array[3], extraInitializers);
    if (k) {
      ctx.static = s, ctx.private = p, access = ctx.access = { has: p ? (x) => __privateIn$1(target, x) : (x) => name in x };
      if (k ^ 3) access.get = p ? (x) => (k ^ 1 ? __privateGet$1 : __privateMethod$1)(x, target, k ^ 4 ? extra : desc.get) : (x) => x[name];
      if (k > 2) access.set = p ? (x, y) => __privateSet$1(x, target, y, k ^ 4 ? extra : desc.set) : (x, y) => x[name] = y;
    }
    it = (0, decorators[i])(k ? k < 4 ? p ? extra : desc[key] : k > 4 ? void 0 : { get: desc.get, set: desc.set } : target, ctx), done._ = 1;
    if (k ^ 4 || it === void 0) __expectFn$1(it) && (k > 4 ? initializers.unshift(it) : k ? p ? extra = it : desc[key] = it : target = it);
    else if (typeof it !== "object" || it === null) __typeError$1("Object expected");
    else __expectFn$1(fn = it.get) && (desc.get = fn), __expectFn$1(fn = it.set) && (desc.set = fn), __expectFn$1(fn = it.init) && initializers.unshift(fn);
  }
  return k || __decoratorMetadata$1(array, target), desc && __defProp$1(target, name, desc), p ? k ^ 4 ? extra : desc : target;
};
var __publicField$1 = (obj, key, value) => __defNormalProp$1(obj, typeof key !== "symbol" ? key + "" : key, value);
var __accessCheck$1 = (obj, member, msg) => member.has(obj) || __typeError$1("Cannot " + msg);
var __privateIn$1 = (member, obj) => Object(obj) !== obj ? __typeError$1('Cannot use the "in" operator on this value') : member.has(obj);
var __privateGet$1 = (obj, member, getter) => (__accessCheck$1(obj, member, "read from private field"), getter ? getter.call(obj) : member.get(obj));
var __privateSet$1 = (obj, member, value, setter) => (__accessCheck$1(obj, member, "write to private field"), setter ? setter.call(obj, value) : member.set(obj, value), value);
var __privateMethod$1 = (obj, member, method) => (__accessCheck$1(obj, member, "access private method"), method);
var _placeholder_dec, _ignoreTabKey_dec, _insertSpaces_dec, _tabSize_dec, _highlight_dec, _code_dec$1, _readonly_dec, _autoStyleLineNumbers_dec, _lineNumbers_dec$1, _PrismEditor_decorators, _init$1;
const isWindows = typeof window !== "undefined" && navigator && /Win/i.test(navigator.platform);
const isMacLike = typeof window !== "undefined" && navigator && /(Mac|iPhone|iPod|iPad)/i.test(navigator.platform);
_PrismEditor_decorators = [inject(HTMLElement), customElement({
  name: "prism-editor",
  template: template$1
})], _lineNumbers_dec$1 = [bindable()], _autoStyleLineNumbers_dec = [bindable()], _readonly_dec = [bindable()], _code_dec$1 = [bindable()], _highlight_dec = [bindable()], _tabSize_dec = [bindable()], _insertSpaces_dec = [bindable()], _ignoreTabKey_dec = [bindable()], _placeholder_dec = [bindable()];
let _PrismEditor = class _PrismEditor2 {
  constructor(_element) {
    this._element = _element;
    __publicField$1(this, "preRef");
    __publicField$1(this, "textAreaRef");
    __publicField$1(this, "_boundedKeydown");
    __publicField$1(this, "lineNumbers", __runInitializers$1(_init$1, 8, this, false)), __runInitializers$1(_init$1, 11, this);
    __publicField$1(this, "autoStyleLineNumbers", __runInitializers$1(_init$1, 12, this, true)), __runInitializers$1(_init$1, 15, this);
    __publicField$1(this, "readonly", __runInitializers$1(_init$1, 16, this, false)), __runInitializers$1(_init$1, 19, this);
    __publicField$1(this, "code", __runInitializers$1(_init$1, 20, this, "")), __runInitializers$1(_init$1, 23, this);
    __publicField$1(this, "highlight", __runInitializers$1(_init$1, 24, this)), __runInitializers$1(_init$1, 27, this);
    __publicField$1(this, "tabSize", __runInitializers$1(_init$1, 28, this, 2)), __runInitializers$1(_init$1, 31, this);
    __publicField$1(this, "insertSpaces", __runInitializers$1(_init$1, 32, this, true)), __runInitializers$1(_init$1, 35, this);
    __publicField$1(this, "ignoreTabKey", __runInitializers$1(_init$1, 36, this, false)), __runInitializers$1(_init$1, 39, this);
    __publicField$1(this, "placeholder", __runInitializers$1(_init$1, 40, this, "")), __runInitializers$1(_init$1, 43, this);
    __publicField$1(this, "capture", true);
    __publicField$1(this, "history", {
      stack: [],
      offset: -1
    });
    __publicField$1(this, "lineNumbersHeight", "20px");
    const style = document.createElement("style");
    style.textContent = styles$1;
    this._element.appendChild(style);
  }
  lineNumbersChanged() {
    this.styleLineNumbers();
    this.setLineNumbersHeight();
  }
  contentChanged() {
    if (this.lineNumbers) {
      this.setLineNumbersHeight();
    }
  }
  get isEmpty() {
    var _a;
    return ((_a = this.code) == null ? void 0 : _a.length) === 0;
  }
  generateContent() {
    const result = Prism.highlight(this.code, Prism.languages["javascript"], "javascript") + "<br />";
    this.contentChanged();
    return result;
  }
  get lineNumbersCount() {
    const totalLines = this.code.split(/\r\n|\n/).length;
    return totalLines;
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  bound(initiator, parent) {
    if (this.code == null) {
      this.code = "";
    }
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  attached(initiator) {
    this.styleLineNumbers();
    this._boundedKeydown = this.handleKeyDown.bind(this);
    this.textAreaRef.addEventListener("keydown", this._boundedKeydown);
    this.codeChanged(this.code, this.code);
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  detaching(initiator, parent) {
    if (this._boundedKeydown) {
      this.textAreaRef.removeEventListener("keydown", this._boundedKeydown);
    }
  }
  setLineNumbersHeight() {
    this.lineNumbersHeight = getComputedStyle(this.preRef).height;
  }
  styleLineNumbers() {
    if (!this.lineNumbers || !this.autoStyleLineNumbers) return;
    const $editor = this.preRef;
    const $lineNumbers = this._element.querySelector(".prism-editor__line-numbers");
    const editorStyles = window.getComputedStyle($editor);
    const btlr = "border-top-left-radius";
    const bblr = "border-bottom-left-radius";
    if (!$lineNumbers) return;
    $lineNumbers.style[btlr] = editorStyles[btlr];
    $lineNumbers.style[bblr] = editorStyles[bblr];
    $editor.style[btlr] = "0";
    $editor.style[bblr] = "0";
    const stylesList = ["background-color", "margin-top", "padding-top", "font-family", "font-size", "line-height"];
    stylesList.forEach((style) => {
      $lineNumbers.style[style] = editorStyles[style];
    });
    $lineNumbers.style["margin-bottom"] = "-" + editorStyles["padding-top"];
  }
  _getLines(text, position) {
    return text.substring(0, position).split("\n");
  }
  _applyEdits(record) {
    const input = this.textAreaRef;
    const last = this.history.stack[this.history.offset];
    if (last && input) {
      this.history.stack[this.history.offset] = {
        ...last,
        selectionStart: input.selectionStart,
        selectionEnd: input.selectionEnd
      };
    }
    this._recordChange(record);
    this._updateInput(record);
  }
  _recordChange(record, overwrite = false) {
    var _a, _b;
    const { stack, offset } = this.history;
    if (stack.length && offset > -1) {
      this.history.stack = stack.slice(0, offset + 1);
      const count = this.history.stack.length;
      if (count > _PrismEditor2._HISTORY_LIMIT) {
        const extras = count - _PrismEditor2._HISTORY_LIMIT;
        this.history.stack = stack.slice(extras, count);
        this.history.offset = Math.max(this.history.offset - extras, 0);
      }
    }
    const timestamp = Date.now();
    if (overwrite) {
      const last = this.history.stack[this.history.offset];
      if (last && timestamp - last.timestamp < _PrismEditor2._HISTORY_TIME_GAP) {
        const re = /[^a-z0-9]([a-z0-9]+)$/i;
        const previous = (_a = this._getLines(last.value, last.selectionStart).pop()) == null ? void 0 : _a.match(re);
        const current = (_b = this._getLines(record.value, record.selectionStart).pop()) == null ? void 0 : _b.match(re);
        if (previous && current && current[1].startsWith(previous[1])) {
          this.history.stack[this.history.offset] = {
            ...record,
            timestamp
          };
          return;
        }
      }
    }
    this.history.stack.push({ ...record, timestamp });
    this.history.offset++;
  }
  _updateInput(record) {
    const input = this.textAreaRef;
    if (!input) return;
    this.code = record.value || "";
    input.value = record.value;
    input.selectionStart = record.selectionStart;
    input.selectionEnd = record.selectionEnd;
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  codeChanged(newValue, oldValue) {
    if (newValue == null) {
      this.code = "";
    }
    const { value, selectionStart, selectionEnd } = this.textAreaRef;
    this._recordChange(
      {
        value,
        selectionStart,
        selectionEnd
      },
      true
    );
    this.preRef.innerHTML = this.generateContent();
  }
  // public handleChange(e: KeyboardEvent): void {
  //   this.$emit('input', value);
  //   // this.props.onValueChange(value);
  // }
  /** Undo */
  undo() {
    const { stack, offset } = this.history;
    const record = stack[offset - 1];
    if (record) {
      this._updateInput(record);
      this.history.offset = Math.max(offset - 1, 0);
    }
  }
  /** Redo */
  redo() {
    const { stack, offset } = this.history;
    const record = stack[offset + 1];
    if (record) {
      this._updateInput(record);
      this.history.offset = Math.min(offset + 1, stack.length - 1);
    }
  }
  handleKeyDown(e) {
    const { tabSize, insertSpaces, ignoreTabKey } = this;
    if (e.defaultPrevented) {
      return;
    }
    if (e.key === _PrismEditor2._KEY_ESCAPE) {
      e.target.blur();
      this.$emit("blur", e);
    }
    const { value, selectionStart, selectionEnd } = e.target;
    const tabCharacter = (insertSpaces ? " " : "	").repeat(tabSize);
    if (e.key === _PrismEditor2._KEY_TAB && !ignoreTabKey && this.capture) {
      e.preventDefault();
      if (e.shiftKey) {
        const linesBeforeCaret = this._getLines(value, selectionStart);
        const startLine = linesBeforeCaret.length - 1;
        const endLine = this._getLines(value, selectionEnd).length - 1;
        const nextValue = value.split("\n").map((line, i) => {
          if (i >= startLine && i <= endLine && line.startsWith(tabCharacter)) {
            return line.substring(tabCharacter.length);
          }
          return line;
        }).join("\n");
        if (value !== nextValue) {
          const startLineText = linesBeforeCaret[startLine];
          this._applyEdits({
            value: nextValue,
            // Move the start cursor if first line in selection was modified
            // It was modified only if it started with a tab
            selectionStart: startLineText.startsWith(tabCharacter) ? selectionStart - tabCharacter.length : selectionStart,
            // Move the end cursor by total number of characters removed
            selectionEnd: selectionEnd - (value.length - nextValue.length)
          });
        }
      } else if (selectionStart !== selectionEnd) {
        const linesBeforeCaret = this._getLines(value, selectionStart);
        const startLine = linesBeforeCaret.length - 1;
        const endLine = this._getLines(value, selectionEnd).length - 1;
        const startLineText = linesBeforeCaret[startLine];
        this._applyEdits({
          value: value.split("\n").map((line, i) => {
            if (i >= startLine && i <= endLine) {
              return tabCharacter + line;
            }
            return line;
          }).join("\n"),
          // Move the start cursor by number of characters added in first line of selection
          // Don't move it if it there was no text before cursor
          selectionStart: /\S/.test(startLineText) ? selectionStart + tabCharacter.length : selectionStart,
          // Move the end cursor by total number of characters added
          selectionEnd: selectionEnd + tabCharacter.length * (endLine - startLine + 1)
        });
      } else {
        const updatedSelection = selectionStart + tabCharacter.length;
        this._applyEdits({
          // Insert tab character at caret
          value: value.substring(0, selectionStart) + tabCharacter + value.substring(selectionEnd),
          // Update caret position
          selectionStart: updatedSelection,
          selectionEnd: updatedSelection
        });
      }
    } else if (e.key === _PrismEditor2._KEY_BACKSPACE) {
      const hasSelection = selectionStart !== selectionEnd;
      const textBeforeCaret = value.substring(0, selectionStart);
      if (textBeforeCaret.endsWith(tabCharacter) && !hasSelection) {
        e.preventDefault();
        const updatedSelection = selectionStart - tabCharacter.length;
        this._applyEdits({
          // Remove tab character at caret
          value: value.substring(0, selectionStart - tabCharacter.length) + value.substring(selectionEnd),
          // Update caret position
          selectionStart: updatedSelection,
          selectionEnd: updatedSelection
        });
      }
    } else if (e.key === _PrismEditor2._KEY_ENTER) {
      if (selectionStart === selectionEnd) {
        const line = this._getLines(value, selectionStart).pop();
        const matches = line == null ? void 0 : line.match(/^\s+/);
        if (matches && matches[0]) {
          e.preventDefault();
          const indent = "\n" + matches[0];
          const updatedSelection = selectionStart + indent.length;
          this._applyEdits({
            // Insert indentation character at caret
            value: value.substring(0, selectionStart) + indent + value.substring(selectionEnd),
            // Update caret position
            selectionStart: updatedSelection,
            selectionEnd: updatedSelection
          });
        }
      }
    } else if (e.key === _PrismEditor2._KEY_PARENS || e.key === _PrismEditor2._KEY_BRACKETS || e.key === _PrismEditor2._KEY_QUOTE || e.key === _PrismEditor2._KEY_BACK_QUOTE) {
      let chars;
      if (e.key === _PrismEditor2._KEY_PARENS && e.shiftKey) {
        chars = ["(", ")"];
      } else if (e.key === _PrismEditor2._KEY_BRACKETS) {
        if (e.shiftKey) {
          chars = ["{", "}"];
        } else {
          chars = ["[", "]"];
        }
      } else if (e.key === _PrismEditor2._KEY_QUOTE) {
        if (e.shiftKey) {
          chars = ['"', '"'];
        } else {
          chars = ["'", "'"];
        }
      } else if (e.key === _PrismEditor2._KEY_BACK_QUOTE && !e.shiftKey) {
        chars = ["`", "`"];
      }
      if (selectionStart !== selectionEnd && chars) {
        e.preventDefault();
        this._applyEdits({
          value: value.substring(0, selectionStart) + chars[0] + value.substring(selectionStart, selectionEnd) + chars[1] + value.substring(selectionEnd),
          // Update caret position
          selectionStart,
          selectionEnd: selectionEnd + 2
        });
      }
    } else if ((isMacLike ? (
      // Trigger undo with ⌘+Z on Mac
      e.metaKey && e.key === _PrismEditor2._KEY_Z
    ) : (
      // Trigger undo with Ctrl+Z on other platforms
      e.ctrlKey && e.key === _PrismEditor2._KEY_Z
    )) && !e.shiftKey && !e.altKey) {
      e.preventDefault();
      this.undo();
    } else if ((isMacLike ? (
      // Trigger redo with ⌘+Shift+Z on Mac
      e.metaKey && e.key === _PrismEditor2._KEY_Z && e.shiftKey
    ) : isWindows ? (
      // Trigger redo with Ctrl+Y on Windows
      e.ctrlKey && e.key === _PrismEditor2._KEY_Y
    ) : (
      // Trigger redo with Ctrl+Shift+Z on other platforms
      e.ctrlKey && e.key === _PrismEditor2._KEY_Z && e.shiftKey
    )) && !e.altKey) {
      e.preventDefault();
      this.redo();
    } else if (e.key === _PrismEditor2._KEY_M && e.ctrlKey && (isMacLike ? e.shiftKey : true)) {
      e.preventDefault();
      this.capture = !this.capture;
    }
  }
  $emit(evName, params) {
    console.log(evName, params);
  }
};
_init$1 = __decoratorStart$1();
__decorateElement$1(_init$1, 5, "lineNumbers", _lineNumbers_dec$1, _PrismEditor);
__decorateElement$1(_init$1, 5, "autoStyleLineNumbers", _autoStyleLineNumbers_dec, _PrismEditor);
__decorateElement$1(_init$1, 5, "readonly", _readonly_dec, _PrismEditor);
__decorateElement$1(_init$1, 5, "code", _code_dec$1, _PrismEditor);
__decorateElement$1(_init$1, 5, "highlight", _highlight_dec, _PrismEditor);
__decorateElement$1(_init$1, 5, "tabSize", _tabSize_dec, _PrismEditor);
__decorateElement$1(_init$1, 5, "insertSpaces", _insertSpaces_dec, _PrismEditor);
__decorateElement$1(_init$1, 5, "ignoreTabKey", _ignoreTabKey_dec, _PrismEditor);
__decorateElement$1(_init$1, 5, "placeholder", _placeholder_dec, _PrismEditor);
_PrismEditor = __decorateElement$1(_init$1, 0, "PrismEditor", _PrismEditor_decorators, _PrismEditor);
__publicField$1(_PrismEditor, "_KEY_ENTER", "Enter");
__publicField$1(_PrismEditor, "_KEY_TAB", "Tab");
__publicField$1(_PrismEditor, "_KEY_BACKSPACE", "Backspace");
__publicField$1(_PrismEditor, "_KEY_Y", "y");
__publicField$1(_PrismEditor, "_KEY_Z", "z");
__publicField$1(_PrismEditor, "_KEY_M", "m");
__publicField$1(_PrismEditor, "_KEY_PARENS", "(");
__publicField$1(_PrismEditor, "_KEY_BRACKETS", "{");
__publicField$1(_PrismEditor, "_KEY_QUOTE", '"');
__publicField$1(_PrismEditor, "_KEY_BACK_QUOTE", "'");
__publicField$1(_PrismEditor, "_KEY_ESCAPE", "Escape");
__publicField$1(_PrismEditor, "_HISTORY_LIMIT", 100);
__publicField$1(_PrismEditor, "_HISTORY_TIME_GAP", 3e3);
__runInitializers$1(_init$1, 1, _PrismEditor);
let PrismEditor = _PrismEditor;
const styles = "code[class*=language-],pre[class*=language-]{color:#ccc;background:none;font-family:Consolas,Monaco,Andale Mono,Ubuntu Mono,monospace;font-size:1em;text-align:left;white-space:pre;word-spacing:normal;word-break:normal;word-wrap:normal;line-height:1.5;-moz-tab-size:4;-o-tab-size:4;tab-size:4;-webkit-hyphens:none;-moz-hyphens:none;-ms-hyphens:none;hyphens:none}pre[class*=language-]{padding:1em;margin:.5em 0;overflow:auto}:not(pre)>code[class*=language-],pre[class*=language-]{background:#2d2d2d}:not(pre)>code[class*=language-]{padding:.1em;border-radius:.3em;white-space:normal}.token.comment,.token.block-comment,.token.prolog,.token.doctype,.token.cdata{color:#999}.token.punctuation{color:#ccc}.token.tag,.token.attr-name,.token.namespace,.token.deleted{color:#e2777a}.token.function-name{color:#6196cc}.token.boolean,.token.number,.token.function{color:#f08d49}.token.property,.token.class-name,.token.constant,.token.symbol{color:#f8c555}.token.selector,.token.important,.token.atrule,.token.keyword,.token.builtin{color:#cc99cd}.token.string,.token.char,.token.attr-value,.token.regex,.token.variable{color:#7ec699}.token.operator,.token.entity,.token.url{color:#67cdcc}.token.important,.token.bold{font-weight:700}.token.italic{font-style:italic}.token.entity{cursor:help}.token.inserted{color:green}pre[class*=language-].line-numbers{position:relative;padding-left:3.8em;counter-reset:linenumber}pre[class*=language-].line-numbers>code{position:relative;white-space:inherit}.line-numbers .line-numbers-rows{position:absolute;pointer-events:none;top:0;font-size:100%;left:-3.8em;width:3em;letter-spacing:-1px;border-right:1px solid #999;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.line-numbers-rows>span{display:block;counter-increment:linenumber}.line-numbers-rows>span:before{content:counter(linenumber);color:#999;display:block;padding-right:.8em;text-align:right}";
const template = `<div>
  <pre class="\${lineNumbers ? 'line-numbers' : ''}" data-start="0"><code ref="codeArea" class="language-\${language}"></code></pre>
</div>

`;
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __knownSymbol = (name, symbol) => (symbol = Symbol[name]) ? symbol : Symbol.for("Symbol." + name);
var __typeError = (msg) => {
  throw TypeError(msg);
};
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __decoratorStart = (base) => [, , , __create(null)];
var __decoratorStrings = ["class", "method", "getter", "setter", "accessor", "field", "value", "get", "set"];
var __expectFn = (fn) => fn !== void 0 && typeof fn !== "function" ? __typeError("Function expected") : fn;
var __decoratorContext = (kind, name, done, metadata, fns) => ({ kind: __decoratorStrings[kind], name, metadata, addInitializer: (fn) => done._ ? __typeError("Already initialized") : fns.push(__expectFn(fn || null)) });
var __decoratorMetadata = (array, target) => __defNormalProp(target, __knownSymbol("metadata"), array[3]);
var __runInitializers = (array, flags, self, value) => {
  for (var i = 0, fns = array[flags >> 1], n = fns && fns.length; i < n; i++) flags & 1 ? fns[i].call(self) : value = fns[i].call(self, value);
  return value;
};
var __decorateElement = (array, flags, name, decorators, target, extra) => {
  var fn, it, done, ctx, access, k = flags & 7, s = !!(flags & 8), p = !!(flags & 16);
  var j = k > 3 ? array.length + 1 : k ? s ? 1 : 2 : 0, key = __decoratorStrings[k + 5];
  var initializers = k > 3 && (array[j - 1] = []), extraInitializers = array[j] || (array[j] = []);
  var desc = k && (!p && !s && (target = target.prototype), k < 5 && (k > 3 || !p) && __getOwnPropDesc(k < 4 ? target : { get [name]() {
    return __privateGet(this, extra);
  }, set [name](x) {
    return __privateSet(this, extra, x);
  } }, name));
  k ? p && k < 4 && __name(extra, (k > 2 ? "set " : k > 1 ? "get " : "") + name) : __name(target, name);
  for (var i = decorators.length - 1; i >= 0; i--) {
    ctx = __decoratorContext(k, name, done = {}, array[3], extraInitializers);
    if (k) {
      ctx.static = s, ctx.private = p, access = ctx.access = { has: p ? (x) => __privateIn(target, x) : (x) => name in x };
      if (k ^ 3) access.get = p ? (x) => (k ^ 1 ? __privateGet : __privateMethod)(x, target, k ^ 4 ? extra : desc.get) : (x) => x[name];
      if (k > 2) access.set = p ? (x, y) => __privateSet(x, target, y, k ^ 4 ? extra : desc.set) : (x, y) => x[name] = y;
    }
    it = (0, decorators[i])(k ? k < 4 ? p ? extra : desc[key] : k > 4 ? void 0 : { get: desc.get, set: desc.set } : target, ctx), done._ = 1;
    if (k ^ 4 || it === void 0) __expectFn(it) && (k > 4 ? initializers.unshift(it) : k ? p ? extra = it : desc[key] = it : target = it);
    else if (typeof it !== "object" || it === null) __typeError("Object expected");
    else __expectFn(fn = it.get) && (desc.get = fn), __expectFn(fn = it.set) && (desc.set = fn), __expectFn(fn = it.init) && initializers.unshift(fn);
  }
  return k || __decoratorMetadata(array, target), desc && __defProp(target, name, desc), p ? k ^ 4 ? extra : desc : target;
};
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
var __accessCheck = (obj, member, msg) => member.has(obj) || __typeError("Cannot " + msg);
var __privateIn = (member, obj) => Object(obj) !== obj ? __typeError('Cannot use the "in" operator on this value') : member.has(obj);
var __privateGet = (obj, member, getter) => (__accessCheck(obj, member, "read from private field"), getter ? getter.call(obj) : member.get(obj));
var __privateSet = (obj, member, value, setter) => (__accessCheck(obj, member, "write to private field"), setter ? setter.call(obj, value) : member.set(obj, value), value);
var __privateMethod = (obj, member, method) => (__accessCheck(obj, member, "access private method"), method);
var _lineNumbers_dec, _language_dec, _code_dec, _PrismView_decorators, _init;
_PrismView_decorators = [customElement({
  name: "prism-view",
  template
}), inject(HTMLElement)], _code_dec = [bindable()], _language_dec = [bindable()], _lineNumbers_dec = [bindable()];
class PrismView {
  constructor(_element) {
    this._element = _element;
    __publicField(this, "codeArea");
    __publicField(this, "code", __runInitializers(_init, 8, this)), __runInitializers(_init, 11, this);
    __publicField(this, "language", __runInitializers(_init, 12, this, "javascript")), __runInitializers(_init, 15, this);
    __publicField(this, "lineNumbers", __runInitializers(_init, 16, this, false)), __runInitializers(_init, 19, this);
    const style = document.createElement("style");
    style.textContent = styles;
    this._element.appendChild(style);
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  attached(initiator) {
    this.codeChanged(this.code, "");
  }
  codeChanged(newValue, oldValue) {
    if (newValue !== oldValue) {
      this.codeArea.textContent = newValue;
      Prism.highlightElement(this.codeArea);
    }
  }
}
_init = __decoratorStart();
__decorateElement(_init, 5, "code", _code_dec, PrismView);
__decorateElement(_init, 5, "language", _language_dec, PrismView);
__decorateElement(_init, 5, "lineNumbers", _lineNumbers_dec, PrismView);
PrismView = __decorateElement(_init, 0, "PrismView", _PrismView_decorators, PrismView);
__runInitializers(_init, 1, PrismView);
export {
  PrismEditor,
  PrismView
};
